function CleanUI_InitDataStoreCollector()
    CleanUIDataStore = CleanUIDataStore or {};

    CleanUI_RegisterDataStoreEvents();

    CleanUI_UpdateMoney();
    CleanUI_UpdateAccountData();

    CleanUI_AddMoneyTooltip();
end

function CleanUI_RegisterDataStoreEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("PLAYER_MONEY");
    frame:RegisterEvent("PLAYER_ENTERING_WORLD");
    frame:RegisterEvent("PLAYER_LEVEL_UP");

    frame:HookScript("OnEvent", CleanUI_DataStoreOnEvent);
end

function CleanUI_DataStoreOnEvent(self, event, ...)
    
    if (event == "PLAYER_MONEY" or event == "PLAYER_ENTERING_WORLD") then
        CleanUI_UpdateMoney();
    end
    
    if (event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_LEVEL_UP") then
        CleanUI_UpdateAccountData();
    end
end

function CleanUI_UpdateAccountData()
    local guid = UnitGUID("player");
    
    local name = UnitName("player");

    CleanUIDataStore['account'] = CleanUIDataStore['account'] or {};
    local account = CleanUIDataStore["account"];
    
    account[guid] = account[guid] or {};
    
    account[guid].name = UnitName("player");
    account[guid].realm = GetRealmName();
    account[guid].class = UnitClass("player");
    account[guid].race = UnitRace("player");
    account[guid].faction = UnitFactionGroup("player");
    account[guid].level = UnitLevel("player");
end

function CleanUI_UpdateMoney()
    CleanUIDataStore["money"] = CleanUIDataStore["money"] or {};    
    local money = CleanUIDataStore["money"];    

    money[UnitGUID("player")] = GetMoney();
end

function CleanUI_ResetMoney()
    CleanUIDataStore["money"] = {};
end