local cursorFrame = CreateFrame("Frame", nil, UIParent);
cursorFrame:SetFrameStrata("TOOLTIP");

local texture = cursorFrame:CreateTexture();
texture:SetTexture("Interface\\Cooldown\\star4");
texture:SetBlendMode("ADD");
texture:SetAlpha(0.4);

local x = 0;
local y = 0;
local speed = 0;

------------------------------------------------------------------------
---- OnUpdate
------------------------------------------------------------------------

local UPDATE_WAIT = 0.01;
local wait = 0;
local function CleanUI_CursorOnUpdate(_, elapsed)
    wait = wait + elapsed;

    if (wait > UPDATE_WAIT) then
        wait = 0;
        CleanUI_CursorDoUpdate(elapsed);
    end
end

function CleanUI_CursorDoUpdate(elapsed)

  local dX = x;
  local dY = y;
  
  x, y = GetCursorPosition();
  
  dX = x - dX;
  dY = y - dY;
  
  local weight = 2048 ^ -elapsed;
  speed = math.min(weight * speed + (1 - weight) * math.sqrt(dX * dX + dY * dY) / elapsed, 1024);
  
  local size = speed / 14 - 16;
  
  if (size > 0) then
    local scale = UIParent:GetEffectiveScale();

    local alpha = size / 60 - 0.4;
    alpha = max(0, alpha);
    alpha = min(0.7, alpha);
    
    texture:SetSize(size, size);
    texture:SetAlpha(alpha);
    texture:SetPoint("CENTER", UIParent, "BOTTOMLEFT", (x + 0.5 * dX) / scale, (y + 0.5 * dY) / scale);
    texture:Show();
  else
    texture:Hide();
  end
end

cursorFrame:SetScript("OnUpdate", CleanUI_CursorOnUpdate);
